Index: issm/trunk/src/c/classes/Elements/PentaRef.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/PentaRef.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/PentaRef.cpp	(revision 18301)
@@ -24,28 +24,12 @@
 #define NUMNODESP2xP1 12
 #define NUMNODESP2    18
+#define NUMNODESP2b   19
 #define NUMNODESP2xP4 30
 
 /*Object constructors and destructor*/
 PentaRef::PentaRef(){/*{{{*/
-	this->element_type_list=NULL;
-}
-/*}}}*/
-PentaRef::PentaRef(const int nummodels){/*{{{*/
-
-	/*Only allocate pointer*/
-	element_type_list=xNew<int>(nummodels);
-
 }
 /*}}}*/
 PentaRef::~PentaRef(){/*{{{*/
-	xDelete<int>(element_type_list);
-}
-/*}}}*/
-
-/*Management*/
-void PentaRef::SetElementType(int type,int type_counter){/*{{{*/
-
-	/*initialize element type*/
-	this->element_type_list[type_counter]=type;
 }
 /*}}}*/
@@ -167,12 +151,4 @@
 	/*Invert Jacobian matrix: */
 	Matrix3x3Invert(Jinv,&J[0][0]);
-}
-/*}}}*/
-void PentaRef::GetNodalFunctions(IssmDouble* basis,Gauss* gauss){/*{{{*/
-	/*This routine returns the values of the nodal functions  at the gaussian point.*/
-
-	_assert_(basis);
-	GetNodalFunctions(basis,gauss,this->element_type);
-
 }
 /*}}}*/
@@ -262,4 +238,30 @@
 			basis[16]=4.*gauss->coord3*gauss->coord1*(1.-zeta*zeta);
 			basis[17]=4.*gauss->coord1*gauss->coord2*(1.-zeta*zeta);
+			return;
+		case P2bubbleEnum: case P2bubblecondensedEnum:
+			/*Corner nodes*/
+			basis[ 0]=gauss->coord1*(2.*gauss->coord1-1.)*zeta*(zeta-1.)/2.;
+			basis[ 1]=gauss->coord2*(2.*gauss->coord2-1.)*zeta*(zeta-1.)/2.;
+			basis[ 2]=gauss->coord3*(2.*gauss->coord3-1.)*zeta*(zeta-1.)/2.;
+			basis[ 3]=gauss->coord1*(2.*gauss->coord1-1.)*zeta*(zeta+1.)/2.;
+			basis[ 4]=gauss->coord2*(2.*gauss->coord2-1.)*zeta*(zeta+1.)/2.;
+			basis[ 5]=gauss->coord3*(2.*gauss->coord3-1.)*zeta*(zeta+1.)/2.;
+			/*mid-sides of quads*/
+			basis[ 6]=gauss->coord1*(2.*gauss->coord1-1.)*(1.-zeta*zeta);
+			basis[ 7]=gauss->coord2*(2.*gauss->coord2-1.)*(1.-zeta*zeta);
+			basis[ 8]=gauss->coord3*(2.*gauss->coord3-1.)*(1.-zeta*zeta);
+			/*mid-sides of triangles*/
+			basis[ 9]=4.*gauss->coord3*gauss->coord2*zeta*(zeta-1.)/2.;
+			basis[10]=4.*gauss->coord3*gauss->coord1*zeta*(zeta-1.)/2.;
+			basis[11]=4.*gauss->coord1*gauss->coord2*zeta*(zeta-1.)/2.;
+			basis[12]=4.*gauss->coord3*gauss->coord2*zeta*(zeta+1.)/2.;
+			basis[13]=4.*gauss->coord3*gauss->coord1*zeta*(zeta+1.)/2.;
+			basis[14]=4.*gauss->coord1*gauss->coord2*zeta*(zeta+1.)/2.;
+			/*quad faces*/
+			basis[15]=4.*gauss->coord3*gauss->coord2*(1.-zeta*zeta);
+			basis[16]=4.*gauss->coord3*gauss->coord1*(1.-zeta*zeta);
+			basis[17]=4.*gauss->coord1*gauss->coord2*(1.-zeta*zeta);
+			/*bubble*/
+			basis[18]=27.*gauss->coord1*gauss->coord2*gauss->coord3*(1.+zeta)*(1.-zeta);
 			return;
 		case P2xP4Enum :
@@ -321,8 +323,4 @@
 }
 /*}}}*/
-void PentaRef::GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
-	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss,this->element_type);
-}
-/*}}}*/
 void PentaRef::GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, Gauss* gauss,int finiteelement){/*{{{*/
 
@@ -356,8 +354,4 @@
 	/*Clean up*/
 	xDelete<IssmDouble>(dbasis_ref);
-}
-/*}}}*/
-void PentaRef::GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,Gauss* gauss){/*{{{*/
-	GetNodalFunctionsDerivativesReference(dbasis,gauss,this->element_type);
 }
 /*}}}*/
@@ -605,4 +599,86 @@
 			dbasis[NUMNODESP2*1+17] = (1.-zeta*zeta)*(-2.*SQRT3/3.*(gauss->coord1+gauss->coord2));
 			dbasis[NUMNODESP2*2+17] = -2.*zeta*4.*gauss->coord1*gauss->coord2;
+			return;
+		case P2bubbleEnum: case P2bubblecondensedEnum:
+			/*Nodal function 1*/
+			dbasis[NUMNODESP2b*0+0 ] = .5*zeta*(zeta-1.)*(-2.*gauss->coord1 + 0.5);
+			dbasis[NUMNODESP2b*1+0 ] = .5*zeta*(zeta-1.)*(-2.*SQRT3/3.*gauss->coord1 + SQRT3/6.);
+			dbasis[NUMNODESP2b*2+0 ] = .5*(2.*zeta-1.)*gauss->coord1*(2.*gauss->coord1-1.);
+			/*Nodal function 2*/
+			dbasis[NUMNODESP2b*0+1 ] = .5*zeta*(zeta-1.)*(+2.*gauss->coord2 - 0.5);
+			dbasis[NUMNODESP2b*1+1 ] = .5*zeta*(zeta-1.)*(-2.*SQRT3/3.*gauss->coord2 + SQRT3/6.);
+			dbasis[NUMNODESP2b*2+1 ] = .5*(2.*zeta-1.)*gauss->coord2*(2.*gauss->coord2-1.);
+			/*Nodal function 3*/
+			dbasis[NUMNODESP2b*0+2 ] = 0.;
+			dbasis[NUMNODESP2b*1+2 ] = .5*zeta*(zeta-1.)*(4.*SQRT3/3.*gauss->coord3 - SQRT3/3.);
+			dbasis[NUMNODESP2b*2+2 ] = .5*(2.*zeta-1.)*gauss->coord3*(2.*gauss->coord3-1.);
+			/*Nodal function 4*/
+			dbasis[NUMNODESP2b*0+3 ] = .5*zeta*(zeta+1.)*(-2.*gauss->coord1 + 0.5);
+			dbasis[NUMNODESP2b*1+3 ] = .5*zeta*(zeta+1.)*(-2.*SQRT3/3.*gauss->coord1 + SQRT3/6.);
+			dbasis[NUMNODESP2b*2+3 ] = .5*(2.*zeta+1.)*gauss->coord1*(2.*gauss->coord1-1.);
+			/*Nodal function 5*/
+			dbasis[NUMNODESP2b*0+4 ] = .5*zeta*(zeta+1.)*(+2.*gauss->coord2 - 0.5);
+			dbasis[NUMNODESP2b*1+4 ] = .5*zeta*(zeta+1.)*(-2.*SQRT3/3.*gauss->coord2 + SQRT3/6.);
+			dbasis[NUMNODESP2b*2+4 ] = .5*(2.*zeta+1.)*gauss->coord2*(2.*gauss->coord2-1.);
+			/*Nodal function 6*/
+			dbasis[NUMNODESP2b*0+5 ] = 0.;
+			dbasis[NUMNODESP2b*1+5 ] = .5*zeta*(zeta+1.)*(4.*SQRT3/3.*gauss->coord3 - SQRT3/3.);
+			dbasis[NUMNODESP2b*2+5 ] = .5*(2.*zeta+1.)*gauss->coord3*(2.*gauss->coord3-1.);
+
+			/*Nodal function 7*/
+			dbasis[NUMNODESP2b*0+6 ] = (-2.*gauss->coord1 + 0.5)*(1.-zeta*zeta);
+			dbasis[NUMNODESP2b*1+6 ] = (-2.*SQRT3/3.*gauss->coord1 + SQRT3/6.)*(1.-zeta*zeta);
+			dbasis[NUMNODESP2b*2+6 ] = -2.*zeta*gauss->coord1*(2.*gauss->coord1-1.);
+			/*Nodal function 8*/
+			dbasis[NUMNODESP2b*0+7 ] = (+2.*gauss->coord2 - 0.5)*(1.-zeta*zeta);
+			dbasis[NUMNODESP2b*1+7 ] = (-2.*SQRT3/3.*gauss->coord2 + SQRT3/6.)*(1.-zeta*zeta);
+			dbasis[NUMNODESP2b*2+7 ] = -2.*zeta*gauss->coord2*(2.*gauss->coord2-1.);
+			/*Nodal function 9*/
+			dbasis[NUMNODESP2b*0+8 ] = 0.;
+			dbasis[NUMNODESP2b*1+8 ] = (+4.*SQRT3/3.*gauss->coord3 - SQRT3/3.)*(1.-zeta*zeta);
+			dbasis[NUMNODESP2b*2+8 ] = -2.*zeta*gauss->coord3*(2.*gauss->coord3-1.);
+
+			/*Nodal function 10*/
+			dbasis[NUMNODESP2b*0+9 ] = zeta*(zeta-1.)*gauss->coord3;
+			dbasis[NUMNODESP2b*1+9 ] = .5*zeta*(zeta-1.)*(+4.*SQRT3/3.*gauss->coord2 - 2.*SQRT3/3.*gauss->coord3);
+			dbasis[NUMNODESP2b*2+9 ] = 2.*gauss->coord3*gauss->coord2*(2.*zeta-1.);
+			/*Nodal function 11*/
+			dbasis[NUMNODESP2b*0+10] = -zeta*(zeta-1.)*gauss->coord3;
+			dbasis[NUMNODESP2b*1+10] = .5*zeta*(zeta-1.)*(+4.*SQRT3/3.*gauss->coord1 - 2.*SQRT3/3.*gauss->coord3);
+			dbasis[NUMNODESP2b*2+10] = 2.*gauss->coord3*gauss->coord1*(2.*zeta-1.);
+			/*Nodal function 12*/
+			dbasis[NUMNODESP2b*0+11] = zeta*(zeta-1.)*(gauss->coord1-gauss->coord2);
+			dbasis[NUMNODESP2b*1+11] = .5*zeta*(zeta-1.)*(-2.*SQRT3/3.*(gauss->coord1+gauss->coord2));
+			dbasis[NUMNODESP2b*2+11] = 2.*gauss->coord1*gauss->coord2*(2.*zeta-1.);
+			/*Nodal function 13*/
+			dbasis[NUMNODESP2b*0+12] = zeta*(zeta+1.)*gauss->coord3;
+			dbasis[NUMNODESP2b*1+12] = .5*zeta*(zeta+1.)*(+4.*SQRT3/3.*gauss->coord2 - 2.*SQRT3/3.*gauss->coord3);
+			dbasis[NUMNODESP2b*2+12] = 2.*gauss->coord3*gauss->coord2*(2.*zeta+1.);
+			/*Nodal function 14*/
+			dbasis[NUMNODESP2b*0+13] = -zeta*(zeta+1.)*gauss->coord3;
+			dbasis[NUMNODESP2b*1+13] = .5*zeta*(zeta+1.)*(+4.*SQRT3/3.*gauss->coord1 - 2.*SQRT3/3.*gauss->coord3);
+			dbasis[NUMNODESP2b*2+13] = 2.*gauss->coord3*gauss->coord1*(2.*zeta+1.);
+			/*Nodal function 15*/
+			dbasis[NUMNODESP2b*0+14] = zeta*(zeta+1.)*(gauss->coord1-gauss->coord2);
+			dbasis[NUMNODESP2b*1+14] = .5*zeta*(zeta+1.)*(-2.*SQRT3/3.*(gauss->coord1+gauss->coord2));
+			dbasis[NUMNODESP2b*2+14] = 2.*gauss->coord1*gauss->coord2*(2.*zeta+1.);
+
+			/*Nodal function 16*/
+			dbasis[NUMNODESP2b*0+15] = 2.*gauss->coord3*(1.-zeta*zeta);
+			dbasis[NUMNODESP2b*1+15] = (1.-zeta*zeta)*(+4.*SQRT3/3.*gauss->coord2 - 2.*SQRT3/3.*gauss->coord3);
+			dbasis[NUMNODESP2b*2+15] = -2.*zeta*4.*gauss->coord3*gauss->coord2;
+			/*Nodal function 17*/
+			dbasis[NUMNODESP2b*0+16] = -2.*gauss->coord3*(1.-zeta*zeta);
+			dbasis[NUMNODESP2b*1+16] = (1.-zeta*zeta)*(+4.*SQRT3/3.*gauss->coord1 - 2.*SQRT3/3.*gauss->coord3);
+			dbasis[NUMNODESP2b*2+16] = -2.*zeta*4.*gauss->coord3*gauss->coord1;
+			/*Nodal function 18*/
+			dbasis[NUMNODESP2b*0+17] = 2.*(gauss->coord1-gauss->coord2)*(1.-zeta*zeta);
+			dbasis[NUMNODESP2b*1+17] = (1.-zeta*zeta)*(-2.*SQRT3/3.*(gauss->coord1+gauss->coord2));
+			dbasis[NUMNODESP2b*2+17] = -2.*zeta*4.*gauss->coord1*gauss->coord2;
+
+			/*Nodal function 19*/
+			dbasis[NUMNODESP2b*0+18] = 27.*(1.+zeta)*(1.-zeta)*(-.5*gauss->coord2*gauss->coord3 + .5*gauss->coord1*gauss->coord3);
+			dbasis[NUMNODESP2b*1+18] = 27.*(1.+zeta)*(1.-zeta)*SQRT3*(-1./6.*gauss->coord2*gauss->coord3 - 1./6.*gauss->coord1*gauss->coord3 +1./3.*gauss->coord1*gauss->coord2);
+			dbasis[NUMNODESP2b*2+18] = -54*gauss->coord1*gauss->coord2*gauss->coord3*zeta;
 			return;
 		case P2xP4Enum :
@@ -784,155 +860,4 @@
 }
 /*}}}*/
-void PentaRef::GetNodalFunctionsMINIDerivatives(IssmDouble* dbasismini,IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
-
-	/*This routine returns the values of the nodal functions derivatives  (with respect to the 
-	 * actual coordinate system): */
-
-	IssmDouble    dbasismini_ref[3][NUMNODESP1b];
-	IssmDouble    Jinv[3][3];
-
-	/*Get derivative values with respect to parametric coordinate system: */
-	GetNodalFunctionsMINIDerivativesReference(&dbasismini_ref[0][0], gauss); 
-
-	/*Get Jacobian invert: */
-	GetJacobianInvert(&Jinv[0][0], xyz_list, gauss);
-
-	/*Build dbasis: 
-	 *
-	 * [dhi/dx]= Jinv'*[dhi/dr]
-	 * [dhi/dy]        [dhi/ds]
-	 * [dhi/dz]        [dhi/dzeta]
-	 */
-
-	for(int i=0;i<NUMNODESP1b;i++){
-		*(dbasismini+NUMNODESP1b*0+i)=Jinv[0][0]*dbasismini_ref[0][i]+Jinv[0][1]*dbasismini_ref[1][i]+Jinv[0][2]*dbasismini_ref[2][i];
-		*(dbasismini+NUMNODESP1b*1+i)=Jinv[1][0]*dbasismini_ref[0][i]+Jinv[1][1]*dbasismini_ref[1][i]+Jinv[1][2]*dbasismini_ref[2][i];
-		*(dbasismini+NUMNODESP1b*2+i)=Jinv[2][0]*dbasismini_ref[0][i]+Jinv[2][1]*dbasismini_ref[1][i]+Jinv[2][2]*dbasismini_ref[2][i];
-	}
-
-}
-/*}}}*/
-void PentaRef::GetNodalFunctionsMINIDerivativesReference(IssmDouble* dbasis,Gauss* gauss_in){/*{{{*/
-	/*This routine returns the values of the nodal functions derivatives  (with respect to the 
-	 * natural coordinate system) at the gaussian point. */
-
-	/*Cast gauss to GaussPenta*/
-	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
-
-
-	IssmDouble zeta=gauss->coord4;
-
-	/*Nodal function 1*/
-	dbasis[NUMNODESP1b*0+0]=-0.5*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1b*1+0]=-SQRT3/6.0*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1b*2+0]=-0.5*gauss->coord1;
-	/*Nodal function 2*/
-	dbasis[NUMNODESP1b*0+1]=0.5*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1b*1+1]=-SQRT3/6.0*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1b*2+1]=-0.5*gauss->coord2;
-	/*Nodal function 3*/
-	dbasis[NUMNODESP1b*0+2]=0.;
-	dbasis[NUMNODESP1b*1+2]=SQRT3/3.0*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1b*2+2]=-0.5*gauss->coord3;
-	/*Nodal function 4*/
-	dbasis[NUMNODESP1b*0+3]=-0.5*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1b*1+3]=-SQRT3/6.0*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1b*2+3]=0.5*gauss->coord1;
-	/*Nodal function 5*/
-	dbasis[NUMNODESP1b*0+4]=0.5*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1b*1+4]=-SQRT3/6.0*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1b*2+4]=0.5*gauss->coord2;
-	/*Nodal function 6*/
-	dbasis[NUMNODESP1b*0+5]=0.;
-	dbasis[NUMNODESP1b*1+5]=SQRT3/3.0*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1b*2+5]=0.5*gauss->coord3;
-	/*Nodal function 7*/
-	dbasis[NUMNODESP1b*0+6]=27.*(1.+zeta)*(1.-zeta)*(-.5*gauss->coord2*gauss->coord3 + .5*gauss->coord1*gauss->coord3);
-	dbasis[NUMNODESP1b*1+6]=27.*(1.+zeta)*(1.-zeta)*SQRT3*(-1./6.*gauss->coord2*gauss->coord3 - 1./6.*gauss->coord1*gauss->coord3 +1./3.*gauss->coord1*gauss->coord2);
-	dbasis[NUMNODESP1b*2+6]=27*gauss->coord1*gauss->coord2*gauss->coord3*(-2.0*zeta);
-}
-/*}}}*/
-void PentaRef::GetNodalFunctionsP1(IssmDouble* basis, Gauss* gauss_in){/*{{{*/
-	/*This routine returns the values of the nodal functions  at the gaussian point.*/
-
-	/*Cast gauss to GaussPenta*/
-	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
-
-	basis[0]=gauss->coord1*(1-gauss->coord4)/2.0;
-	basis[1]=gauss->coord2*(1-gauss->coord4)/2.0;
-	basis[2]=gauss->coord3*(1-gauss->coord4)/2.0;
-	basis[3]=gauss->coord1*(1+gauss->coord4)/2.0;
-	basis[4]=gauss->coord2*(1+gauss->coord4)/2.0;
-	basis[5]=gauss->coord3*(1+gauss->coord4)/2.0;
-
-}
-/*}}}*/
-void PentaRef::GetNodalFunctionsP1Derivatives(IssmDouble* dbasis,IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
-
-	/*This routine returns the values of the nodal functions derivatives  (with respect to the 
-	 * actual coordinate system): */
-	IssmDouble    dbasis_ref[NDOF3][NUMNODESP1];
-	IssmDouble    Jinv[NDOF3][NDOF3];
-
-	/*Get derivative values with respect to parametric coordinate system: */
-	GetNodalFunctionsP1DerivativesReference(&dbasis_ref[0][0], gauss); 
-
-	/*Get Jacobian invert: */
-	GetJacobianInvert(&Jinv[0][0], xyz_list, gauss);
-
-	/*Build dh1dh3: 
-	 *
-	 * [dhi/dx]= Jinv*[dhi/dr]
-	 * [dhi/dy]       [dhi/ds]
-	 * [dhi/dz]       [dhi/dn]
-	 */
-
-	for (int i=0;i<NUMNODESP1;i++){
-		*(dbasis+NUMNODESP1*0+i)=Jinv[0][0]*dbasis_ref[0][i]+Jinv[0][1]*dbasis_ref[1][i]+Jinv[0][2]*dbasis_ref[2][i];
-		*(dbasis+NUMNODESP1*1+i)=Jinv[1][0]*dbasis_ref[0][i]+Jinv[1][1]*dbasis_ref[1][i]+Jinv[1][2]*dbasis_ref[2][i];
-		*(dbasis+NUMNODESP1*2+i)=Jinv[2][0]*dbasis_ref[0][i]+Jinv[2][1]*dbasis_ref[1][i]+Jinv[2][2]*dbasis_ref[2][i];
-	}
-
-}
-/*}}}*/
-void PentaRef::GetNodalFunctionsP1DerivativesReference(IssmDouble* dbasis,Gauss* gauss_in){/*{{{*/
-
-	/*This routine returns the values of the nodal functions derivatives  (with respect to the 
-	 * natural coordinate system) at the gaussian point. Those values vary along xi,eta,z */
-
-	/*Cast gauss to GaussPenta*/
-	_assert_(gauss_in->Enum()==GaussPentaEnum);
-	GaussPenta* gauss = dynamic_cast<GaussPenta*>(gauss_in);
-
-	IssmDouble zeta=gauss->coord4;
-
-	/*Nodal function 1*/
-	dbasis[NUMNODESP1*0+0]=-0.5*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1*1+0]=-SQRT3/6.0*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1*2+0]=-0.5*gauss->coord1;
-	/*Nodal function 2*/
-	dbasis[NUMNODESP1*0+1]=0.5*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1*1+1]=-SQRT3/6.0*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1*2+1]=-0.5*gauss->coord2;
-	/*Nodal function 3*/
-	dbasis[NUMNODESP1*0+2]=0.;
-	dbasis[NUMNODESP1*1+2]=SQRT3/3.0*(1.0-zeta)/2.0;
-	dbasis[NUMNODESP1*2+2]=-0.5*gauss->coord3;
-	/*Nodal function 4*/
-	dbasis[NUMNODESP1*0+3]=-0.5*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1*1+3]=-SQRT3/6.0*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1*2+3]=0.5*gauss->coord1;
-	/*Nodal function 5*/
-	dbasis[NUMNODESP1*0+4]=0.5*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1*1+4]=-SQRT3/6.0*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1*2+4]=0.5*gauss->coord2;
-	/*Nodal function 6*/
-	dbasis[NUMNODESP1*0+5]=0.;
-	dbasis[NUMNODESP1*1+5]=SQRT3/3.0*(1.0+zeta)/2.0;
-	dbasis[NUMNODESP1*2+5]=0.5*gauss->coord3;
-}
-/*}}}*/
 void PentaRef::GetQuadJacobianDeterminant(IssmDouble* Jdet,IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
 	/*This routine returns the values of the nodal functions  at the gaussian point.*/
@@ -960,10 +885,4 @@
 }
 /*}}}*/
-void PentaRef::GetInputValue(IssmDouble* pvalue,IssmDouble* plist,Gauss* gauss){/*{{{*/
-
-	GetInputValue(pvalue,plist,gauss,this->element_type);
-
-}
-/*}}}*/
 void PentaRef::GetInputValue(IssmDouble* pvalue,IssmDouble* plist,Gauss* gauss,int finiteelement){/*{{{*/
 
@@ -987,5 +906,5 @@
 }
 /*}}}*/
-void PentaRef::GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
+void PentaRef::GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, Gauss* gauss,int finiteelement){/*{{{*/
 	/*From node values of parameter p (p_list[0], p_list[1], p_list[2],
 	 * p_list[3], p_list[4] and p_list[4]), return parameter derivative value at
@@ -1004,9 +923,9 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(finiteelement);
 
 	/*Get nodal functions derivatives*/
 	IssmDouble* dbasis=xNew<IssmDouble>(3*numnodes);
-	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss);
+	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss,finiteelement);
 
 	/*Calculate parameter for this Gauss point*/
@@ -1023,19 +942,20 @@
 }
 /*}}}*/
-int  PentaRef::NumberofNodes(void){/*{{{*/
-
-	return this->NumberofNodes(this->element_type);
-}
-/*}}}*/
 int  PentaRef::NumberofNodes(int finiteelement){/*{{{*/
 
 	switch(finiteelement){
+		case NoneEnum:              return 0;
 		case P0Enum:                return NUMNODESP0;
 		case P1Enum:                return NUMNODESP1;
+		case P1DGEnum:              return NUMNODESP1;
 		case P1bubbleEnum:          return NUMNODESP1b;
 		case P1bubblecondensedEnum: return NUMNODESP1b;
 		case P2Enum:                return NUMNODESP2;
+		case P2bubbleEnum:          return NUMNODESP2b;
+		case P2bubblecondensedEnum: return NUMNODESP2b;
 		case P2xP1Enum:             return NUMNODESP2xP1;
 		case P1xP2Enum:             return NUMNODESP1xP2;
+		case P2xP4Enum:             return NUMNODESP2xP4;
+		case P1xP3Enum:             return NUMNODESP1xP3;
 		case P1P1Enum:              return NUMNODESP1*2;
 		case P1P1GLSEnum:           return NUMNODESP1*2;
@@ -1043,8 +963,8 @@
 		case MINIEnum:              return NUMNODESP1b+NUMNODESP1;
 		case TaylorHoodEnum:        return NUMNODESP2+NUMNODESP1;
+		case LATaylorHoodEnum:      return NUMNODESP2;
 		case OneLayerP4zEnum:       return NUMNODESP2xP4+NUMNODESP1;
-		case P2xP4Enum:             return NUMNODESP2xP4;
-		case P1xP3Enum:             return NUMNODESP1xP3;
-		default:       _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+		case CrouzeixRaviartEnum:   return NUMNODESP2b+NUMNODESP1;
+		default:       _error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
 	}
 
@@ -1052,14 +972,16 @@
 }
 /*}}}*/
-int  PentaRef::VelocityInterpolation(void){/*{{{*/
-
-	switch(this->element_type){
-		case P1P1Enum:          return P1Enum;
-		case P1P1GLSEnum:       return P1Enum;
-		case MINIcondensedEnum: return P1bubbleEnum;
-		case MINIEnum:          return P1bubbleEnum;
-		case TaylorHoodEnum:    return P2Enum;
-		case OneLayerP4zEnum:   return P2xP4Enum;
-		default:       _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+int  PentaRef::VelocityInterpolation(int fe_stokes){/*{{{*/
+
+	switch(fe_stokes){
+		case P1P1Enum:           return P1Enum;
+		case P1P1GLSEnum:        return P1Enum;
+		case MINIcondensedEnum:  return P1bubbleEnum;
+		case MINIEnum:           return P1bubbleEnum;
+		case TaylorHoodEnum:     return P2Enum;
+		case LATaylorHoodEnum:   return P2Enum;
+		case OneLayerP4zEnum:    return P2xP4Enum;
+		case CrouzeixRaviartEnum:return P2bubbleEnum;
+		default:       _error_("Element type "<<EnumToStringx(fe_stokes)<<" not supported yet");
 	}
 
@@ -1067,14 +989,16 @@
 }
 /*}}}*/
-int  PentaRef::PressureInterpolation(void){/*{{{*/
-
-	switch(this->element_type){
-		case P1P1Enum:          return P1Enum;
-		case P1P1GLSEnum:       return P1Enum;
-		case MINIcondensedEnum: return P1Enum;
-		case MINIEnum:          return P1Enum;
-		case TaylorHoodEnum:    return P1Enum;
-		case OneLayerP4zEnum:   return P1Enum;
-		default:       _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+int  PentaRef::PressureInterpolation(int fe_stokes){/*{{{*/
+
+	switch(fe_stokes){
+		case P1P1Enum:           return P1Enum;
+		case P1P1GLSEnum:        return P1Enum;
+		case MINIcondensedEnum:  return P1Enum;
+		case MINIEnum:           return P1Enum;
+		case TaylorHoodEnum:     return P1Enum;
+		case LATaylorHoodEnum:   return NoneEnum;
+		case OneLayerP4zEnum:    return P1Enum;
+		case CrouzeixRaviartEnum:return P1DGEnum;
+		default:       _error_("Element type "<<EnumToStringx(fe_stokes)<<" not supported yet");
 	}
 
@@ -1082,9 +1006,9 @@
 }
 /*}}}*/
-int  PentaRef::TensorInterpolation(void){/*{{{*/
-
-	switch(this->element_type){
+int  PentaRef::TensorInterpolation(int fe_stokes){/*{{{*/
+
+	switch(fe_stokes){
 		case XTaylorHoodEnum:    return P1DGEnum;
-		default: _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+		default: _error_("Element type "<<EnumToStringx(fe_stokes)<<" not supported yet");
 	}
 
@@ -1147,4 +1071,14 @@
 			indices[5] = 11;
 			break;
+		case P2bubbleEnum:
+			numindices = 6;
+			indices    = xNew<int>(numindices);
+			indices[0] = 0;
+			indices[1] = 1;
+			indices[2] = 2;
+			indices[3] = 9;
+			indices[4] = 10;
+			indices[5] = 11;
+			break;
 		case P2xP4Enum:
 			numindices = 6;
@@ -1158,5 +1092,5 @@
 			break;
 		default:
-			_error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+			_error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
 	}
 
@@ -1215,5 +1149,5 @@
 			break;
 		default:
-			_error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+			_error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
 	}
 
Index: issm/trunk/src/c/classes/Elements/PentaRef.h
===================================================================
--- issm/trunk/src/c/classes/Elements/PentaRef.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/PentaRef.h	(revision 18301)
@@ -11,26 +11,11 @@
 
 	public: 
-		int* element_type_list; //P1CG, P1DG, MINI, P2...
-		int  element_type;
-
 		PentaRef();
-		PentaRef(const int nummodels);
 		~PentaRef();
 
-		/*Management*/
-		void SetElementType(int type,int type_counter);
-
 		/*Numerics*/
-		void GetNodalFunctions(IssmDouble* basis, Gauss* gauss);
 		void GetNodalFunctions(IssmDouble* basis, Gauss* gauss,int finiteelement);
-		void GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss);
 		void GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss,int finiteelement);
-		void GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,Gauss* gauss);
 		void GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,Gauss* gauss,int finiteelement);
-		void GetNodalFunctionsP1(IssmDouble* l1l6, Gauss* gauss);
-		void GetNodalFunctionsP1Derivatives(IssmDouble* dh1dh6,IssmDouble* xyz_list, Gauss* gauss);
-		void GetNodalFunctionsMINIDerivatives(IssmDouble* dh1dh7,IssmDouble* xyz_list, Gauss* gauss);
-		void GetNodalFunctionsP1DerivativesReference(IssmDouble* dl1dl6,Gauss* gauss);
-		void GetNodalFunctionsMINIDerivativesReference(IssmDouble* dl1dl7,Gauss* gauss);
 		void GetQuadJacobianDeterminant(IssmDouble*  Jdet, IssmDouble* xyz_list,Gauss* gauss);
 		void GetJacobian(IssmDouble* J, IssmDouble* xyz_list,Gauss* gauss);
@@ -40,15 +25,13 @@
 		void GetJacobianInvert(IssmDouble*  Jinv, IssmDouble* xyz_list,Gauss* gauss);
 		void GetLprimeFSSSA(IssmDouble* LprimeFSSSA, IssmDouble* xyz_list, Gauss* gauss);
-		void GetInputValue(IssmDouble* pvalue,IssmDouble* plist, Gauss* gauss);
 		void GetInputValue(IssmDouble* pvalue,IssmDouble* plist, Gauss* gauss,int finiteelement);
-		void GetInputDerivativeValue(IssmDouble* pvalues, IssmDouble* plist,IssmDouble* xyz_list, Gauss* gauss);
+		void GetInputDerivativeValue(IssmDouble* pvalues, IssmDouble* plist,IssmDouble* xyz_list, Gauss* gauss,int finiteelement);
 
 		void BasalNodeIndices(int* pnumindices,int** pindices,int finiteelement);
 		void SurfaceNodeIndices(int* pnumindices,int** pindices,int finiteelement);
-		int  NumberofNodes(void);
 		int  NumberofNodes(int finiteelement);
-		int  VelocityInterpolation(void);
-		int  PressureInterpolation(void);
-		int  TensorInterpolation(void);
+		int  VelocityInterpolation(int fe_stokes);
+		int  PressureInterpolation(int fe_stokes);
+		int  TensorInterpolation(int fe_stokes);
 };
 #endif
Index: issm/trunk/src/c/classes/Elements/Seg.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Seg.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Seg.cpp	(revision 18301)
@@ -20,5 +20,5 @@
 /*Constructors/destructor/copy*/
 Seg::Seg(int seg_id, int seg_sid, int index, IoModel* iomodel,int nummodels)/*{{{*/
-		:SegRef(nummodels),ElementHook(nummodels,index+1,NUMVERTICES,iomodel){
+		:ElementHook(nummodels,index+1,NUMVERTICES,iomodel){
 
 			/*id: */
@@ -37,4 +37,7 @@
 			this->material = NULL;
 			this->matpar   = NULL;
+
+			/*Only allocate pointer*/
+			this->element_type_list=xNew<int>(nummodels);
 		}
 /*}}}*/
@@ -99,6 +102,20 @@
 	*pxyz_front=xyz_front;
 }/*}}}*/
+void       Seg::NodalFunctionsP1(IssmDouble* basis, Gauss* gauss){/*{{{*/
+
+	_assert_(gauss->Enum()==GaussSegEnum);
+	this->GetNodalFunctions(basis,(GaussSeg*)gauss,P1Enum);
+
+}
+/*}}}*/
+void       Seg::NodalFunctionsP2(IssmDouble* basis, Gauss* gauss){/*{{{*/
+
+	_assert_(gauss->Enum()==GaussSegEnum);
+	this->GetNodalFunctions(basis,(GaussSeg*)gauss,P2Enum);
+
+}
+/*}}}*/
 int        Seg::GetNumberOfNodes(void){/*{{{*/
-	return this->NumberofNodes();
+	return this->NumberofNodes(this->element_type);
 }
 /*}}}*/
@@ -116,126 +133,4 @@
 
 }/*}}}*/
-void       Seg::GradientIndexing(int* indexing,int control_index){/*{{{*/
-
-	/*Get some parameters*/
-	int num_controls;
-	parameters->FindParam(&num_controls,InversionNumControlParametersEnum);
-
-	/*get gradient indices*/
-	for(int i=0;i<NUMVERTICES;i++){
-		indexing[i]=num_controls*this->vertices[i]->Pid() + control_index;
-	}
-
-}
-/*}}}*/
-void       Seg::GradjDragFS(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	int        i;
-	int        analysis_type;
-	int        vertexpidlist[NUMVERTICES];
-	int        connectivity[NUMVERTICES];
-	IssmDouble vx,lambda,alpha_complement,drag,Jdet;
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble dk[NDOF2]; 
-	IssmDouble grade_g[NUMVERTICES]={0.0};
-	IssmDouble grade_g_gaussian[NUMVERTICES];
-	IssmDouble basis[3];
-	Friction*  friction=NULL;
-	GaussSeg  *gauss=NULL;
-
-	if(IsFloating())return;
-
-	/*retrive parameters: */
-	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&vertexpidlist[0],control_index);
-	this->GetVerticesConnectivityList(&connectivity[0]);
-
-	/*Build frictoin element, needed later: */
-	friction=new Friction(this,1);
-
-	/*Retrieve all inputs we will be needing: */
-	Input* adjointx_input=inputs->GetInput(AdjointxEnum);                   _assert_(adjointx_input);
-	Input* vx_input=inputs->GetInput(VxEnum);                               _assert_(vx_input);
-	Input* dragcoefficient_input=inputs->GetInput(FrictionCoefficientEnum); _assert_(dragcoefficient_input);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussSeg(4);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctions(basis, gauss);
-
-		/*Build alpha_complement_list: */
-		friction->GetAlphaComplement(&alpha_complement,gauss);
-
-		dragcoefficient_input->GetInputValue(&drag, gauss);
-		adjointx_input->GetInputValue(&lambda, gauss);
-		vx_input->GetInputValue(&vx,gauss);
-		dragcoefficient_input->GetInputDerivativeValue(&dk[0],&xyz_list[0][0],gauss);
-
-		/*Build gradje_g_gaussian vector (actually -dJ/ddrag): */
-		for (i=0;i<NUMVERTICES;i++){
-			grade_g_gaussian[i]=-2*drag*alpha_complement*(lambda*vx)*Jdet*gauss->weight*basis[i];
-		}
-
-		/*Add gradje_g_gaussian vector to gradje_g: */
-		for(i=0;i<NUMVERTICES;i++){
-			_assert_(!xIsNan<IssmDouble>(grade_g[i]));
-			grade_g[i]+=grade_g_gaussian[i];
-		}
-	}
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	/*Clean up and return*/
-	delete gauss;
-	delete friction;
-}
-/*}}}*/
-void       Seg::GradjDragGradient(Vector<IssmDouble>* gradient,int control_index){/*{{{*/
-
-	int        i;
-	int        vertexpidlist[NUMVERTICES];
-	IssmDouble Jdet,weight;
-	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble dbasis[NDOF2][NUMVERTICES];
-	IssmDouble dk[NDOF2]; 
-	IssmDouble grade_g[NUMVERTICES]={0.0};
-	GaussSeg  *gauss=NULL;
-
-	/*Retrieve all inputs we will be needing: */
-	if(IsFloating())return;
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	GradientIndexing(&vertexpidlist[0],control_index);
-	Input* dragcoefficient_input=inputs->GetInput(FrictionCoefficientEnum); _assert_(dragcoefficient_input);
-	Input* weights_input=inputs->GetInput(InversionCostFunctionsCoefficientsEnum);                 _assert_(weights_input);
-
-	/* Start  looping on the number of gaussian points: */
-	gauss=new GaussSeg(2);
-	for(int ig=gauss->begin();ig<gauss->end();ig++){
-
-		gauss->GaussPoint(ig);
-
-		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetNodalFunctionsDerivatives(&dbasis[0][0],&xyz_list[0][0],gauss);
-		weights_input->GetInputValue(&weight,gauss,DragCoefficientAbsGradientEnum);
-
-		/*Build alpha_complement_list: */
-		dragcoefficient_input->GetInputDerivativeValue(&dk[0],&xyz_list[0][0],gauss);
-
-		/*Build gradje_g_gaussian vector (actually -dJ/ddrag): */
-		for (i=0;i<NUMVERTICES;i++){
-			grade_g[i]+=-weight*Jdet*gauss->weight*dbasis[0][i]*dk[0];
-			_assert_(!xIsNan<IssmDouble>(grade_g[i]));
-		}
-	}
-	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
-
-	/*Clean up and return*/
-	delete gauss;
-}
-/*}}}*/
 bool       Seg::IsIcefront(void){/*{{{*/
 
@@ -299,5 +194,5 @@
 
 	_assert_(gauss->Enum()==GaussSegEnum);
-	this->GetNodalFunctions(basis,(GaussSeg*)gauss);
+	this->GetNodalFunctions(basis,(GaussSeg*)gauss,this->element_type);
 
 }
@@ -306,5 +201,5 @@
 
 	_assert_(gauss->Enum()==GaussSegEnum);
-	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussSeg*)gauss);
+	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussSeg*)gauss,this->element_type);
 
 }
